package ;

import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.StageAlign;
import flash.display.StageScaleMode;
import flash.geom.Rectangle;
import flash.Lib;
import flash.text.TextField;
import ScreenPressor;
import flash.net.URLLoader;
import flash.net.URLRequest;
import flash.events.Event;
import flash.net.URLLoaderDataFormat;
import flash.utils.ByteArray;
import flash.utils.Endian;
import flash.Memory;
import IVideoCodec;
import haxe.Timer;
import flash.external.ExternalInterface;

class Main 
{	
	static function main() 
	{
		var stage = Lib.current.stage;
		stage.scaleMode = StageScaleMode.NO_SCALE;
		stage.align = StageAlign.TOP_LEFT;
		// entry point
		g_main = new Main();
	}
	
	static var g_main : Main;
	var loader : URLLoader;
	var txt : TextField;
	var sp : ScreenPressor;
	var bitmap : Bitmap;
	var bitmap_data : BitmapData;
	var data : ByteArray;
	
	public function new() {
		txt = new TextField();
		txt.x = 10; txt.y = 550; txt.text = "Loading image..."; txt.width = 900;
		Lib.current.stage.addChild(txt);
		
		var req = new URLRequest("blow.spi");
		loader = new URLLoader();
		loader.addEventListener(Event.COMPLETE, on_image_loaded);
		loader.dataFormat =  URLLoaderDataFormat.BINARY;
		loader.load(req);		
	}
	
	function on_image_loaded(event:Event) : Void
	{
		var arr : ByteArray = loader.data;
		txt.text = "Loaded " + arr.length + " bytes";

		data = new ByteArray();
		data.length = arr.length - 4;
		arr.position = 4;
		arr.readBytes(data);
		
		if (ExternalInterface.available) 
			ExternalInterface.addCallback("bench", bench);
		//Timer.delay(function() { decodeAndShow(data); }, 50);
	}
	
	function bench(n : Int) : Void
	{
		if (n < 0 || n > 1000) { 
			txt.text = "You must be joking!";
			return;
		}
		txt.text = "Decompressing " + n + " times...";
		if (Lib.current.stage.numChildren > 2)
			Lib.current.stage.removeChildAt(2);
		Timer.delay(function() { decodeAndShow(n); }, 50);
		//decodeAndShow(n);
	}
	
	function decodeAndShow(N:Int) {
		var X = 960, Y = 540;
		sp = new ScreenPressor(X, Y, 1, 24);
		var addr_buffers = sp.BufferStartAddr();
		var buffer_size = X * Y * 4;		
		var m = new ByteArray();
		m.length = addr_buffers + buffer_size;
		m.endian = Endian.LITTLE_ENDIAN;
		m.position = 0;
		Memory.select(m);
		sp.Preinit(0);
		var t0 = Timer.stamp();		
		for(repeats in 0...N) {		
			sp.RenewI();
			sp.DecompressI(data, addr_buffers);					
		}
		var t1 = Timer.stamp();
		txt.text = " t=" + (t1 - t0);
		
		for (i in 0 ... X*Y) {
			var b = Memory.getByte(addr_buffers + i * 4);
			var r = Memory.getByte(addr_buffers + i * 4 + 2);
			Memory.setByte(addr_buffers + i * 4, r);
			Memory.setByte(addr_buffers + i * 4 + 2, b);
		}
		
		var rect = new Rectangle(0,0,X,Y);
		bitmap_data = new BitmapData(X, Y, false);
		bitmap = new Bitmap(bitmap_data);
		Lib.current.stage.addChild(bitmap);
		flash.system.ApplicationDomain.currentDomain.domainMemory.position = addr_buffers;
		//flash.system.ApplicationDomain.currentDomain.domainMemory.endian = Endian.LITTLE_ENDIAN;
		bitmap_data.lock();
		bitmap_data.setPixels( rect , flash.system.ApplicationDomain.currentDomain.domainMemory );
		bitmap_data.unlock();
		bitmap.x = 0; bitmap.y = 0;
	}
}