package ;

import flash.Memory;
import flash.utils.ByteArray;
#if logging
import flash.external.ExternalInterface;
#end

class RangeCoder 
{
	//var low : UInt;
	var range : UInt;
	var code : UInt;
	//var ffnum : UInt;
	//var cache : UInt;
		
	static inline var TOP = 0x01000000;
	static inline var BOT =   0x010000;
	
	#if logging
	var nlogged : Int = 0;
	public static var dolog = true;
	public static inline function JSLog(msg:String):Void
	{		
		if (ExternalInterface.available && dolog)
			ExternalInterface.call("playerLog", msg);
	}
	#end
	
	public function new() 
	{		
	}

	public function DecodeBegin(src : ByteArray):Void
	{
		code = 0;
		range = 0xFFFFFFFF;		
		code=(code<<8) | src.readUnsignedByte();
		code=(code<<8) | src.readUnsignedByte();
		code=(code<<8) | src.readUnsignedByte();
		code=(code<<8) | src.readUnsignedByte();
		code = (code << 8) | src.readUnsignedByte();
		#if logging
		JSLog("DecodeBegin code=" + code);
		#end
	}
	
	inline function decode(cumFreq :UInt, freq:UInt, total_freq:UInt, src:ByteArray) :Void
	{
		code -= cumFreq*range;
		range *= freq;
		while ( range < TOP ) { 
			code = (code << 8) | src.readUnsignedByte();  range <<= 8; 
		}
		#if logging
		JSLog("decode cumFreq=" + cumFreq + " freq=" + freq + " totFr=" +total_freq + " code=" + code + " range=" + range);
		nlogged ++;
		if (nlogged > 10) dolog = false;
		#end
	}
	
 	inline function get_freq(total_freq:Int):Int 
	{
		range = Std.int(range / total_freq);
		return Std.int(code / range);
	}
	
	static inline function mem(arr:Int, idx:Int):Int
	{
		return Memory.getI32(arr + (idx << 2));
	}
	
	static inline function memset(arr:Int, idx:Int, val:Int):Void
	{
		Memory.setI32(arr + (idx << 2), val);
	}
	
	//cnt is pointer in Memory, totfr is cnt[maxc]
	public inline function DecodeVal(cnt:Int, maxc:Int, step:Int, src:ByteArray):Int 
	{
		var totfr = mem(cnt, maxc);
		var value = get_freq(totfr);
		var c = 0;
		var cumfr = 0;
		var cnt_c = 0;
		while (c < maxc) {	
			cnt_c = mem(cnt, c);
			if (value >= cumfr + cnt_c)	
				cumfr += cnt_c;	
			else
				break;
			c++;
		}	
		decode(cumfr, cnt_c, totfr, src);
	
		memset(cnt, c, cnt_c + step);
		totfr += step;		
		if (totfr > BOT) {
			totfr = 0;
			for (i in 0...maxc) {
				var nc = (mem(cnt, i) >> 1) + 1;
				memset(cnt, i, nc);///	cnt[i] = (cnt[i]>>1)+1;
				totfr += nc;
			}			
		}
		memset(cnt, maxc, totfr);
		return c;
	}
	
	//cnt is pointer in Memory, 16 + 1 + 256 ints,  totfr is mem(cnt, 16)  cnt[c] is mem(cnt, c+17)
	public inline function DecodeValUni(cnt:Int, step:Int, src:ByteArray):Int
	{
		var totfr = mem(cnt, 16);
		var value = get_freq(totfr);

		var x = 0;
		var cumfr = 0;
		var cnt_x = 0;
		while (x < 16) {
			cnt_x = mem(cnt, x);
			if (value >= cumfr + cnt_x)
				cumfr += cnt_x;
			else
				break;
			x++;
		}

		var c = x * 16;
		var cnt_c = 0;
		while (c < 256) {
			cnt_c = mem(cnt, c + 17);
			if (value >= cumfr + cnt_c)
				cumfr += cnt_c;
			else
				break;
			c++;
		}
		decode(cumfr, cnt_c, totfr, src);
		memset(cnt, c + 17, cnt_c + step); ///	cnt[c] += step;
		memset(cnt, x, cnt_x + step); ///	cnt[256+x] += step;
		totfr += step;
		if (totfr > BOT) {
			totfr = 0;
			for (i in 17...(256+17)) {
				var nc = (mem(cnt, i /*+ 17*/) >> 1) + 1;
				memset(cnt, i /*+ 17*/, nc); ///cnt[i] = (cnt[i]>>1)+1;
				totfr += nc;
			}
			for(i in 0...16) {
				var sum = 0;
				var i16_17 = (i << 4) + 17;
				for(j in 0...16)
					sum += mem(cnt, i16_17 + j);///cnt[256+i] += cnt[i*16+j];
				memset(cnt, i, sum);
			}
		}
		memset(cnt, 16, totfr);
		return c;
	}
}