package ;
import flash.Memory;
import flash.utils.ByteArray;
import flash.Vector;
import RangeCoder;
import flash.utils.Endian;
import IVideoCodec;

class ScreenPressor 
{
	static inline var SC_STEP = 400;
	static inline var SC_NSTEP = 400;
	static inline var SC_CXSHIFT = 2;
	static inline var SC_CXMAX = 4096;
	static inline var SC_NCXMAX = 6;
	static inline var SC_UNSTEP = 1000; 
	
	var X : Int;
	var Y : Int;
	var rc : RangeCoder;
	
	/*inline function MAKECX1():Void
	{
		cx1 = (cx<<6)&0xFC0;
	}*/
	
	static inline function mem(arr:Int, idx:Int):Int
	{
		return Memory.getI32(arr + (idx << 2));
	}
	
	static inline function memset(arr:Int, idx:Int, val:Int):Void
	{
		Memory.setI32(arr + (idx << 2), val);
	}


	///uint *cntab[3][SC_CXMAX];
	inline function cntab(channel:Int, context:Int):Int //returns pointer in Memory
	{
		return ((channel << 12) + context) * 1092; //4 * (273 == 16 + 1 + 256)
	}
	
	static inline var addr_ntab = 13418496; // 3 * 4096 * 273 * 4
	///uint *ntab[SC_NCXMAX]
	static inline function ntab(context:Int):Int
	{
		return addr_ntab + context * 1028; //4 * (256 + 1)
	}
	
	static inline var addr_ptypetab = addr_ntab + 6 * 1028;
	static inline function ptypetab(context:Int):Int
	{
		return addr_ptypetab + context * 28;
	}
	
	static inline var addr_end_tables = addr_ptypetab + 6 * 28;
	
	public function new(width:Int, height:Int, num_buffers:Int, bits_per_pixel:Int) //num_frames - number of decompressed frames to store in memory
	{
		//trace("ScreenPressor.new: bpp=" + bits_per_pixel + " w=" + width + " h=" + height);
		X = width; Y = height; 
		rc = new RangeCoder();
	}
	
	public function Preinit(insignificant_lines : Int):Void //must be called after memory is allocated
	{
		//trace("SP.Preinit");
		for (chan in 0...3)
			for (ctx in 0...SC_CXMAX) {
				var p = cntab(chan, ctx);				
				memset(p, 16, 0); //mark as not set
			}		
	}
	
	public function BufferStartAddr():Int
	{
		return addr_end_tables;
	}
	
	public function RenewI():Void
	{
		//trace("SP.RenewI");
		
		for (chan in 0...3)
			for (ctx in 0...SC_CXMAX) {
				var p = cntab(chan, ctx);
				if (mem(p, 16) != 256) { //fill if changed
					for (i in 0...256)
						memset(p, i+17, 1);
					for (i in 0...16)
						memset(p, i, 16);
					memset(p, 16, 256);
				}
			}
		for (ncx in 0...SC_NCXMAX) {
			var p = ntab(ncx);
			for (i in 0...256)
				memset(p, i, 1);
			memset(p, 256, 256);			
		}
		
		for (ctx in 0...6) {
			var p = ptypetab(ctx);
			for (i in 0...6)
				memset(p, i, 1);
			memset(p, 6, 6);
		}				
	}
	
	public function DecompressI(src:ByteArray, buffer_address:Int):Void 
	{
		var di = buffer_address; //start of decompressed data
		var end = di + X * Y * 4;
		var clr = 0; var lasti = di;
		var cx = 0, cx1 = 0;
		
		//trace("SP.DecompressI src.size=" + src.length + " bpp="+bpp + " rnd=" + Math.random());
			src.position = 0;
		
			var head = src.readByte();
			if (head != 0x12) {
				trace("unknown version of the codec"); return;
			}
			rc.DecodeBegin(src);
			cx = cx1 = 0;
			var k = 0; 
			
			lasti = di;
			while(k<X+1) {
				///pSrc = DecodeRGB(pSrc, r,g,b);
				var r = rc.DecodeValUni(cntab(0, cx+cx1), SC_STEP, src);
				cx1 = (cx<<6)&0xFC0;
				cx = r>>SC_CXSHIFT;
				var g = rc.DecodeValUni(cntab(1, cx+cx1), SC_STEP, src);
				cx1 = (cx<<6)&0xFC0;
				cx = g>>SC_CXSHIFT;
				var b = rc.DecodeValUni(cntab(2, cx+cx1), SC_STEP, src);
				cx1 = (cx<<6)&0xFC0;
				cx = b>>SC_CXSHIFT;			
				
				var n = rc.DecodeVal(ntab(0), 256, SC_NSTEP, src);
				clr = (b << 16) + (g << 8) + r;
				for (x in 0...n) {
					Memory.setI32(di, clr);
					lasti = di;
					di += 4;
				}			
				k += n;
			}
		var off = -X * 4 - 4;
		var ptype = 0;	
		var last_pos = 0;
		var last_di_segment = di & 0xFFFF0000;
		
		while(di < end) {
			ptype = rc.DecodeVal(ptypetab(ptype), 6, SC_UNSTEP, src);
			if (ptype==0) {
				///pSrc = DecodeRGB(pSrc, r, g, b);	
				var r = rc.DecodeValUni(cntab(0, cx + cx1), SC_STEP, src);
				cx1 = (cx<<6)&0xFC0;
				cx = r >> SC_CXSHIFT;
				var g = rc.DecodeValUni(cntab(1, cx + cx1), SC_STEP, src);
				cx1 = (cx<<6)&0xFC0;
				cx = g >> SC_CXSHIFT;
				var b = rc.DecodeValUni(cntab(2, cx + cx1), SC_STEP, src);
				cx1 = (cx<<6)&0xFC0;
				cx = b >> SC_CXSHIFT;		
				clr = (b << 16) + (g << 8) + r;
			}			
			var n = rc.DecodeVal(ntab(ptype), 256, SC_NSTEP, src);
			/*for(j in 0...n) {
				switch(ptype) {
					case 1: clr = Memory.getI32(lasti);  ///r = pDst[lasti]; g = pDst[lasti+1]; b = pDst[lasti+2];					
					case 2: clr = Memory.getI32(di + off + 4); ///	r = pDst[i+off+3]; g = pDst[i+off+4]; b = pDst[i+off+5];					
					case 4:
						var r = Memory.getByte(lasti) + Memory.getByte(di + off + 4) - Memory.getByte(di + off);
						var g = Memory.getByte(lasti+1) + Memory.getByte(di + off + 5) - Memory.getByte(di + off+1);
						var b = Memory.getByte(lasti+2) + Memory.getByte(di + off + 6) - Memory.getByte(di + off+2);
						clr = ((b & 0xFF) << 16) + ((g & 0xFF) << 8) + (r & 0xFF);
					case 5: clr = Memory.getI32(di + off);	///r = pDst[i+off]; g = pDst[i+off+1]; b = pDst[i+off+2];					
				}	
				Memory.setI32(di, clr);
				lasti = di;
				di += 4;			
			}*/
			
			switch(ptype) {
				case 0:  
					while (n-->0) {
						Memory.setI32(di, clr);	di += 4;									
					}
					lasti = di - 4;
				case 1:
					while (n-->0) {
						clr = Memory.getI32(lasti);
						Memory.setI32(di, clr);	lasti = di;	di += 4;									
					}
				case 2:
					while (n-->0) {
						clr = Memory.getI32(di + off + 4);
						Memory.setI32(di, clr);	di += 4;									
					}
					lasti = di - 4;
				case 4:
					while (n-->0) {
						var r = Memory.getByte(lasti) + Memory.getByte(di + off + 4) - Memory.getByte(di + off);
						var g = Memory.getByte(lasti+1) + Memory.getByte(di + off + 5) - Memory.getByte(di + off+1);
						var b = Memory.getByte(lasti+2) + Memory.getByte(di + off + 6) - Memory.getByte(di + off+2);
						clr = ((b & 0xFF) << 16) + ((g & 0xFF) << 8) + (r & 0xFF);
						Memory.setI32(di, clr);	lasti = di;	di += 4;									
					}
				case 5:
					while (n-->0) {
						clr = Memory.getI32(di + off);	
						Memory.setI32(di, clr);	di += 4;									
					}
					lasti = di - 4;
			}
			
			cx1 = (clr & 0xFC00) >> 4;
			cx = clr >> 18;		
		}
	}	
}